<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <title> Pipeline Visualization API </title>
    
    <link rel="canonical" href="https://getbootstrap.com/docs/5.0/examples/sidebars/">
    <link rel="stylesheet" href="./statics/css/toggle.css">
    <link rel="stylesheet" href="./statics/css/bootstrap.min.css", rel="stylesheet">
    
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">

    <script src="https://cdn.jsdelivr.net/npm/xml-digester@0.0.5/lib/xml-digester.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>

    <script src="https://d3js.org/d3.v7.min.js"></script>

    <script src="./statics/js/bootstrap.bundle.min.js"></script>
    <script src="./statics/js/sidebars.js"></script>    
  
    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <!-- Optional theme -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css" integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
    <!-- Latest compiled and minified JavaScript -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
    
    <script src="./statics/js/tree.js"></script>
    <script type="module" src="./static/js/index.js"></script>

    <style media="screen">
        .tooltip {
        position: absolute;
        text-align: center;
        width:auto;
        height: auto;
        padding: 10px;
        font: 16px sans-serif;
        background: lightsteelblue;
        border: 10px;
        border-radius: 8px;
        pointer-events: none;
        }
        .label {
          font: 8px sans-serif;
        }
        .imagelogo {
          padding-left:  20px;
          padding-right:  20px;
        }
        #range-label {
          padding-left:  20px;
        }
        #ref-genome {
          padding-left:  20px;
          font-weight:bold;
        }
        #densite
        {
          padding-left:  20px;
        }
        #cartesvg
        {
          padding-left:  20px;
          background-color: black;
        }
    </style>


</head>
<body>
    <input type="hidden" value="{{file}}" id="file">
    <h2>Phyloscape</h2>
    <nav class="navbar navbar-default navbar-fixed-top">
      <div id="waiting"><img src='loading.gif' width="150px"/>
      <img  width="300px" src="./statics/img/logo_gismonda.png"></div>
      <div id="loading">Loading data, please wait ...</div>
          <!-- Bouton Display -->
          <div id="menus">
          <div class="btn-group" id="display" >
                  <button type="button" class="btn btn-default btn-sm dropdown-toggle" data-toggle="dropdown" data-toggle="tooltip" data-placement="top" title="Choose information to display" >
                    Display
                    <span class="caret"></span>
                  </button>
                  <ul class="dropdown-menu">
                    <li><a href="#" id="code" data-value="code" >2 letters</a></li>
                    <li><a href="#" id="short" data-value="short" >Genus</a></li>
                    <li><a href="#" id="long" data-value="long" >Species</a></li>
                    <!-- <li><a href="#" class="small" data-value="code" tabIndex="-1"><input type="checkbox" id="code"/>&nbsp;2 letter</a></li>
                    <li><a href="#" class="small" data-value="short" tabIndex="-1"><input type="checkbox" id="short"/>&nbsp;Genus</a></li>
                    <li><a href="#" class="small" data-value="long" tabIndex="-1"><input type="checkbox" id="long"/>&nbsp;Species</a></li> -->
                    <li><a href="#" class="small" data-value="intname" tabIndex="-1"><input type="checkbox" id="intname" checked=true/>&nbsp;Internal nodes</a></li>
                  </ul>
                </div>
                <!-- Division pour eventuel bouton crossref -->
                <div class="btn-group" id="crossref"></div>
                <!-- Bouton Action -->
                <div class="btn-group" role="group" id="action">
                  <button type="button" class="btn btn-default btn-sm dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" data-toggle="tooltip" data-placement="top" title="Choose action on node"  >
                    On click
                    <span class="caret"></span>
                  </button>
                  <ul class="dropdown-menu">
                    <li><a href="#" id="switch">Switch children</a></li>
                    <li><a href="#" id="collapse">Collapse/Expand</a></li>
                    <li><a href="#" id="subtree">Sub Tree/Upper Tree</a></li>
                    <li><a href="#" id="reference">Choose as reference</a></li>
                  </ul>
                </div>
                <!-- Bouton Colourscale -->
                <div class="btn-group" role="group" id="colourscale">
                  <button type="button" class="btn btn-default btn-sm dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" data-toggle="tooltip" data-placement="top" title="Choose colour scale"  >
                    Colour scale
                    <span class="caret"></span>
                  </button>
                  <ul class="dropdown-menu">
                    <li><a href="#" id="colourscale1">White to Blue</a></li>
                    <li><a href="#" id="colourscale2">Blue to White</a></li>
                    <li><a href="#" id="colourscale3">Green to Red</a></li>
                    <li><a href="#" id="colourscale4">Red to Green</a></li>
                  </ul>
                </div>
                <!-- Bouton Zoom level -->
                <div class="btn-group" role="group" id="zoomlevel">
                  <button type="button" class="btn btn-default btn-sm dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" data-toggle="tooltip" data-placement="top" title="Choose zoom level"  >
                    Zoom level
                    <span class="caret"></span>
                  </button>
                  <ul class="dropdown-menu">
                    <li><a href="#" id="zoomlevel1">250 genes/bloc</a></li>
                    <li><a href="#" id="zoomlevel2">100 genes/bloc</a></li>
                    <li><a href="#" id="zoomlevel3">50 genes/bloc</a></li>
                    <li><a href="#" id="zoomlevel4">10 genes/bloc</a></li>
                    <li><a href="#" id="zoomlevel5">1 gene/bloc</a></li>
                  </ul>
                </div>
                <!-- Bouton Collapse -->
<!--                 <button type="button" class="btn btn-default btn-sm" aria-label="Collapse" data-toggle="tooltip" data-placement="top" title="Collapse the tree" id="globalcollapse">
                  <span>Compact tree</span>
                </button> -->
                <!-- Bouton Expand all -->
<!--                 <button type="button" class="btn btn-default btn-sm" aria-label="Expand"  data-toggle="tooltip" data-placement="top" title="Expand the tree (takes time on big trees!)" id="globalexpand">
                  <span>Expand tree</span>
                </button> -->
                <!-- Bouton whole tree -->
                <button type="button" class="btn btn-default btn-sm" aria-label="Whole"  data-toggle="tooltip" data-placement="top" title="Display whole tree and all genomes" id="whole">
                  <span>Whole view</span>
                </button>

                <!-- Bouton Increase tree width -->
                <button type="button" class="btn btn-default btn-sm" aria-label="Left Align" id="moreTreeWidth"  data-toggle="tooltip" data-placement="top" title="Increase tree width">
                  <span>Width</span>
                  <span class="glyphicon glyphicon-plus" aria-hidden="true"></span>
                </button>
                <!-- Bouton Reduce width -->
                <button type="button" class="btn btn-default  btn-sm  " aria-label="Left Align" id="lessTreeWidth"  data-toggle="tooltip" data-placement="top" title="Reduce tree width">
                  <span>Width</span>
                  <span class="glyphicon glyphicon-minus" aria-hidden="true"></span>
                </button>
                <!-- Bouton Increase height -->
                <button type="button" class="btn btn-default btn-sm" aria-label="Left Align" id="moreHeigth"  data-toggle="tooltip" data-placement="top" title="Increase tree height">
                  <span>Height</span>
                  <span class="glyphicon glyphicon-plus" aria-hidden="true"></span>
                </button>
                <!-- Bouton Reduce height -->
                <button type="button" class="btn btn-default btn-sm" aria-label="Left Align" id="lessHeigth"  data-toggle="tooltip" data-placement="top" title="Reduce tree height">
                  <span>Height</span>
                  <span class="glyphicon glyphicon-minus" aria-hidden="true"></span>
                </button>
                <!-- Bouton Reduce height -->
                <!-- <button type="button" class="btn btn-default btn-sm" aria-label="Full" id="full"  data-toggle="tooltip" data-placement="top" title="Full height or height proportional to gene conservation">
                  <span>Full/Relative</span>
                  <span class="glyphicon glyphicon-signal" aria-hidden="true"></span>
                </button> -->
                <!-- Bouton  Export -->
                <button type="button" class="btn btn-default btn-sm" aria-label="ExportSVG" id="export" data-toggle="tooltip" data-placement="top" title="Export the SVG">
                  <span>Export SVG</span>
                </button>
          </div>
          <div id="carte">
            <div id="range-label"></div>
            <div id="densite"></div>
            <div id="ref-genome"></div>
            <!-- <div class="logo"><img class="imagelogo" width="80px" src="logo.png"></div> -->
            <svg id="cartesvg" width="2000px" height="70px"></svg>
          </div>
        </nav>
         <div class="svg-container">
          <svg id="click" xmlns="http://www.w3.org/2000/svg" width="600" height="150">
            <defs>
              <g id="pointer" transform="scale(0.8)">
                <path d="M0-1c-14.5-25.6-14.5-25.7-14.5-33.8c0-8.1,6.5-14.6,14.5-14.6s14.5,6.6,14.5,14.6C14.5-26.7,14.5-26.6,0-1z"></path>
                <path d="M0-49c7.7,0,14,6.3,14,14.1c0,8,0,8.1-14,32.8c-14-24.7-14-24.9-14-32.8C-14-42.7-7.7-49,0-49 M0-50c-8.3,0-15,6.8-15,15.1 S-15-26.5,0,0c15-26.5,15-26.5,15-34.9S8.3-50,0-50L0-50z"></path>
              </g>
            </defs>
          </svg>
        </div>
    <svg id="mainsvg">
    </svg>

    
</body>

<script>

displayTree() 

    function displayTree() {
        let file = $("#file").val()
        fetch(`/phylotree?file=${encodeURI(file)}`)
            .then((response) => response.text())
            .then(data =>{
                const parser = new DOMParser();
                const doc = parser.parseFromString(data, "application/xml");
                result = transformToJson(doc.childNodes[0]);                
                /*let hierarchy = d3.hierarchy(result.phyloxml.phylogeny.clade, function(d){
                    return d.clade;
                })*/
                dessineMoiUnArbre(result);
            
            });
        }


    function isBlank(chain){        
        return !/\S/.test(chain);
    }

    function getKey(obj){
        for (let key in obj){
            return key;
        }
    }

    function updateDict(dict, child) {
        let child_key = getKey(child);
        if (child_key && !dict[child_key]) {
            dict[child_key] = []
        }
        if (child){
            dict[child_key].push(child[child_key])
        }   
    }

    function transformToJson(node){
        //Case of Text node
        if (node.nodeType===Node.TEXT_NODE){
            // We don't care about \n and \t 
            if (!isBlank(node.nodeValue)){
                return { "_text": node.nodeValue }
            }
            return undefined;
        }

        if (node.nodeType===Node.ATTRIBUTE_NODE){
            let result = {};
            result[node.nodeName] = node.nodeValue;
            return result;
        }

        //Element node case
        let elementKey = node.nodeName;
        
        let dict = {};
        let result = {};
        if(node.attributes){            
            for (let attributeNode of node.attributes){
                let child = transformToJson(attributeNode);
                updateDict(dict,child)             
            }
        }

        for (let childNode of node.childNodes) {
            let child = transformToJson(childNode);
            updateDict(dict,child)             
        }

        //The array contains just one value we affect the value
        for (key in dict){
            if (dict[key].length==1){
                dict[key]=dict[key][0];
            }
        }

        // The dictionnary contain only one textnode
        if (Object.keys(dict).length==1 && dict["_text"]){
            result[elementKey]=dict["_text"]
            return result;
        }

        if (elementKey==="eventsRec"){
            let tab = []
            for (let key in dict){
                dict[key]["eventType"]=key
                tab.push(dict[key]);
            }
            result[elementKey]=tab;
            return result;
        }

        result[elementKey]=dict;
        return result;
    }

</script>

</html>